/************************************************************************
* \brief: NeoPhysIx - ultra fast 3D-physics simulation                  *
*																		*
* (c) copyright by Jrn Fischer											*
*                                                                       *
*        ***  ITS PROHIBITED TO DISTRIBUTE THIS SOURCE!  ***            *
*        ***************************************************            *
*																		* 
* @autor: Prof.Dr.Jrn Fischer											*
* @email: j.fischer@hs-mannheim.de										*
*                                                                       *
* @file : neuralNetworks.h                                              *
*************************************************************************/
#ifndef NEURALNETWORK_H
#define NEURALNETWORK_H

#define NEURON_NUMBER MAX_JOINTS

struct cell{

	FLOAT_32 weight[NEURON_NUMBER];
	FLOAT_32 output;
	FLOAT_32 activity;
	FLOAT_32 bias;
	FLOAT_32 tau;
};

class network{

public:
	struct cell neuron[NEURON_NUMBER];
	// -------------------------------------------------------------------------------
	// --- init neurons --------------------------------------------------------------
	// -------------------------------------------------------------------------------
	void initNeurons();

	// -------------------------------------------------------------------------------
	// --- exp -----------------------------------------------------------------------
	// -------------------------------------------------------------------------------
	FLOAT_32 tanH(FLOAT_32 xx);

	// -------------------------------------------------------------------------------
	// --- activate ------------------------------------------------------------------
	// -------------------------------------------------------------------------------
	void activate(FLOAT_32* input, int numOfInputs);
};
#endif // NEURALNETWORK_H




